伤城文章网 > PPT模板 > UNIX Shell 程序设计

UNIX Shell 程序设计


UNIX Shell 程序设计
UNIX Shell概述
Shell启动及其命令

Shell命令的集成
Shell 变量 Shell的控制结构

Shell的运行环境

UNIX Shell概述
? ? ? ? ?

什么是 Shell
Shell的双重特性 Shell程序语言的特点

Shell的版本
Shell版本的选择

1.1 什么是 Shell
U N I X 系 统 层 次 结 构 图

1.1 什么是 Shell
Shell就是UNIX提供用户的使用界面 。
Shell处在内核与外层应用程序之间,起着

协调用户与系统的一致性、在用户与系统
之间进行交互的作用,即 Shell为用户提供 了输入命令和参数并可得到命令执行结果 的环境。

1.2 Shell的双重特性
? 命令解释程序(命令解释器)
Shell解释用户输入的命令行,提交系统内 核处理,并将结果返回给用户; Shell与UNIX命令一样都是实用程序,但有区 别。一旦用户注册到系统后, Shell 就被系统装 入内存,并一直运行到用户退出系统之止;而一 般命令仅当被调用时,才由系统装入内存执行。

? 程序设计语言
Shell本身也是一种可编程的程序设计语言。

1.3 Shell程序语言的特点
Shell允许通过编程来完成复杂的功能处理,
但其作为语言与高级语言比较具有不同的特点: ? Shell是解释性的,多数高级语言是编译性的; ? Shell语言与高级语言处理的对象不同; ? Shell与系统有密切的关系; ? Shell易编写、调试、灵活性较强. ? Shell作为命令级语言,命令组合功能很强。

1.4 Shell的版本
常用Shell在交互式使用方面的比较
Shell ? ± à ? ק? ? ? ? Bourne (sh) ? × ? ? Korn (ksh) ? ? ? ? Bourne Again(bash) ? ? POSIX (psh) ? ? ? ? C (csh) ? ? ? ? TC (tcsh) ? ? Z (zsh) ? ? à ? ±? ? ? ? ? ? ? ? ? ? ? ? ? ? ? ? ? ? ? ì ? ? ? ? ? ? ? ? ? ? ? ? ? ? ? ? ? ? ? ? ? ? ? ? ? ? ? ? ? ? ? ? ? ? ? ? ? ? ? ? ? ? ? ? ? ? ? ? ? ? ?

Shell有两种主要语法类型:Bourne和C,彼此不兼容, Bourne家族:sh ksh bash psh zsh C 家族:csh tcsh 其中: bash和 zsh在不同程度上支持 csh 的语法。

1.5 Shell版本的选择
选择Shell版本应考虑的因素: ? Bourne Shell在任何一个UNIX系统平台上都
存在,因此又成为标准Shell; ? Bourne Shell家族有更丰富的程序语言,而 C Shell家族有简单的程序接口; ? Shell各类变种功能越来越强大,但学习和使 用也越难,因此可依据使用者编程经验来选择; ? Shell编程的脚本是个人使用还是公用,即要 考虑移植性问题。

Shell启动及其命令
?
? ? ? ?

Shell的启动
命令的格式 命令的查询 Shell常用的命令 Shell的内部命令

2.1 Shell的启动
? 登录Shell的启动
在/etc/passwd文件中指定要启动的Shell。 root : x : 0 : 1 : super user : / : / sbin / sh feng : x : 201 : starf : / home : / bin / csh

? 命令行状态下的交互Shell启动
在系统中可能有多种版本的Shell存在,可通
过相应的命令来启动,如:csh ksh sh

2.2 命令格式
UNIX系统命令的一般格式为:
command [options] [arguments] [filenames] options 或 switches(常带有一个连字号“-‖) 字符标志位,以此扩展命令的特性或功能; arguments 表示命令的自变量(参数); filenames 表示文件或目录的名字。

2.3 命令的查询
环境变量PATH的构成决定了寻找Shell命令和 其它程序的途径,是影响Shell程序效率的主要因 素之一。PATH变量设置要考虑以下几点: ? 常用目录放在PATH变量中,使用频度高的
目录排在前面;

? PATH应尽可能地短,不要出现重复的目录; ? 尽量避免查询大目录,如需设置,将其路径 放在PATH路径的最后位置。 例: PATH=/bin:/usr/bin:/etc:.

2.4 Shell常用的命令
UNIX有丰富的Shell命令,大致划分为以下几 类:目录操作与管理、文件操作与管理命令、 系统管理与维护、用户管理与维护、 系统状态、 进程管理、通讯命令 、 其它命令。例: awk bc cat chmod chown cp cron date df diff du echo expr file find grep init kill ln login ls mail make man mkdir mkfs mount mv nohup pg pwd ps pr pwd read rm sed sort sync tail tee wc

2.5 Shell的内部命令
出于运行效率的考虑,将一些命令构造在Shell
的内部。这些命令比非内部命令执行速度快。

Shell常用的内部命令有:
用于结构分支及控制: if else for case while until continue break

其它 :
# read cd echo eval exec exit export readonly set shift test time trap unset umask wait

Shell命令的集成
? ? ? ?

元字符(通配符)和文件名生成
管道和命令表

命令组合
命令替换

?

输入输出重定向(改向)

3.1 元字符和文件名生成
? UNIX元字符(通配符)的定义
匹配任何单个字符; [ … , - , ! ] 按照范围“-”、列表“...”或不匹配 “!”等形式匹配指定的字符; 转意符,使元字符失去其特殊的含义。 例:[a-d,x,y] 匹配字符a、b、c、d、x、y; z* 匹配以字符z开始的任何字符串; x?y 匹配以x开始、以y结束、中间为任何 单个字 符的字符串; [!Z] 匹配不为Z的单个字符。

* ? \

匹配任何字符串,包括空字符串;

3.1 元字符和文件名生成(续)
? 元字符作为文件扩展名的使用 例:[a-f]* 匹配字符a到字符f开头的文件名; abc d2 e3.c f.dat *z 匹配以字符z结尾的任何字符串; win.z core.zz a-c_5z rc?.d 匹配以rc开始、以.d结束、中间为任 何单个字符的文件名; rc0.d rc2.d rcS.d *[!o] 匹配不以o结尾的文件名;

3.2 管道和命令表
? 管道的概念 管道:是一个命令的标准输出与另一个命令 的标准输入之间的连接,不经过任何中间文件; 管道线:是由管道操作符分隔的一个命令序 列,最简单的管道线是一个简单命令; 管道操作符:用符号“|‖表示。 例: who | wc -l ps -ef | grep ftp ls -l

? 命令表的概念

3.2 管道和命令表(续1)

命令表:一串管道线(命令)构成了一个命令表,最简 单的命令表是一个管道线(即一个简单命令)。 管道线(命令)分隔符:分隔命令表元素,确定管道 线执行的条件,含义如下: ;或 换行符 :表示按顺序执行管道线; && : 表示根据条件(true),执行其后面的管道线; | | : 表示根据条件(false),执行其后面的管道 线; & : 表示前面的管道线在后台(异步)执行。

3.2 管道和命令表(续2)
例1:四个管道线构成一个命令表 ls -l /bin /usr/bin who | wc -l a|b|c|d ps 例2:与例1等价 ls -l /bin /usr/bin ;who | wc -l ;a | b | c | d;ps 例3:sys_account & 例4:查询指定的文件是否存在,给出相应信息 test -f $1 && echo ―$1 exists‖

test -f $1 | | echo ―$1 not exists‖

3.3 命令组合
命令组合有两种形式:
? { 命令表 }
由当前Shell来执行命令表。 例:{ cd mydoc ;rm junk;}

? ( 命令表 )
当前Shell派生一个子Shell进程来执行命令表。 例:( cd mydoc ;rm junk;)

3.4 命令替换
用命令的执行结果来替换这个字符串本身。
注意 反撇号与单引号的区别。 例1:# now=?date‘ ? 单引号 # echo $now date # now=`date` ? 单撇号 # echo $now 1999年 12月 8日 星期三 19时 51分 56秒 CST 例2: # count=10 # count=`expr $count + 1` # echo $count 11

3.5 输入、输出重定向
? 使用标准改向符进行重定向(改向)
< > 输入改向 输出改向

3.5 输入、输出重定向(续1)
? 标准输入的改向(< ) ? command < file
例:sort < myfile wc –l < myfile

3.5 输入、输出重定向(续2)
? 标准输出的改向(>)
? command > file
例1:date > myfile
例2:cat file* > myfile

例3:ps -ef | grep ftp > myfile

3.5 输入、输出重定向 ( 续3 )
? 标准错误输出的改向(>)
? command 2 >file ? command 2 >>file 例:将错误输出改向到err_file文件。 myprog 2 > err_file

Shell变量
?
? ? ? ? ? ?

Shell变量 用户自定义变量 位置变量 环境变量 预定义的特殊变量 变量替换 特殊字符的引用

4.1 Shell变量
? Shell实际上是基于字符串的程序设计语言,
也具有变量。变量的名字必须以字母或下划线

开头,可以包括字母、数字和下划线。

? Shell变量能够而且只能存储正文字符串,
即它只有一种类型的变量——串变量。

? 从赋值的形式上看,则可以分成四种类型
的变量或变量形式。

? 语法格式:name=string

4.2 用户自定义变量
赋值号“=”两边不允许有空白符; nodehost="beijing.UUCP ‖ path=/bin:/usr/bin:/etc/bin count=10

? 允许多个赋值操作,按从右到左的顺序进行;
# A=$B B=abc C="OK" # echo $A $B $C abc abc OK

? 当引用一个未设置的变量时,其隐含值为空;
# echo "$mail is path of mailbox‖ is path of mailbox

? 如果用双引号“”将值括起来,则括起来的
字符串允许出现空格、制表符和换行符的特殊字 符,而且允许有变量替换。
例1:# MAIL=/var/mail/fk # var="$MAIL is a path of mailbox" # echo $var /var/mail/fk is a path of mailbox 例2:# str="This is \n a book" # echo $str This is a book

4.2 用户自定义变量(续1)

4.2 用户自定义变量(续2)
? 如果用单引号‘’将值括起来,则括起来的
字符串允许出现空格、制表符和换行符的特殊字 符,但不允许有变量替换。
例1 # BOOK="English book" # MSG='$BOOK' # echo $MSG $BOOK 例2 # msg=' Today is \t Sunday' # echo $msg Today is Sunday

4.2 用户自定义变量(续3)
? 引用变量的值时,可以用花括号{}将变量名
称括起来,使变量名称与它的后续字符分隔开, 如果紧跟在变量名称后面的字符是字母、数字或 下划线时,必须要使用花括号。 例: # str='This is a string' # echo "${str}ent test of variables" This is a stringent test of variables # echo "$strent test of variables" test of variables

4.3 位置变量
位置变量顾名思义是与位置有关的变量,这 是一种特殊的变量。命令行的Shell过程名本身被 指定为位置变量$0,依次参数为$1 …. $9 。 例:ls / /bin /etc /usr/bin /dev …
? ? ? ? ? ?

$0 $1 $2 $3 $4 例:# cat finduser who | grep $1 # finduser fke

$5



4.4 环境变量
Shell执行环境由一系列环境变量组成,这些变 量是由Shell维护和管理的。所有这些变量都可被 用户重新设置,变量名由大写字母或数字组成。
CDPATH:执行cd命令时使用的搜索路径; HOME :用户的home目录; IFS :内部的域分隔符,一般为空格符、制表符或 换行符; MAIL : 指定特定文件(信箱)的路径,供邮件系统用; PATH :寻找命令或可执行文件的搜索路径; PS1 : 主命令提示符,默认为“$‖; PS2 : 从命令提示符,默认为“>‖; TERM : 使用的终端类型。

4.5 预定义的特殊变量
在Shell中有一组特殊的变量,其变量名和变 量值只有Shell本身才可以设置。 ? $# — 记录传递给Shell的自变量个数; 例1: # myprog a b c 则 $#的值为 3
例2: if test $# -lt 2 then echo ―two or more args required‖ exit fi

4.5 预定义的特殊变量(续1)
? $? — 取最近一次命令执行后的退出状态(返
回码) :执行成功返回码为0, 执行 失 败返回码为1; 例:# test -r my_file (假设my_file文件不可 读) # echo $? 1

? $$ — 当前Shell的进程号 ; ? $! — 取最后一个在后台运行的(使用“&‖)
进程的进程号 ;

4.5 预定义的特殊变量(续2)
? $* — 匹配所有位置变量 ;
? ? ? ? 用 $* 匹配 $1 $2 $3 … “$*” 匹配 “$1 $2 $3 …‖ $@ 匹配 $1 $2 $3 … “$@” 匹配 “$1‖ ― $2‖ ―$3 ‖ … 的选项,或用set命令方式所提供的选项。

? $@ — 匹配所有位置变量 ;

? $- — Shell的标志位,既在Shell启动时使

4.6 变量替换
变量替换表达式一览表 Shell在遇到未设置的变量时,将其值作为空
串处理。而在实际应用中,对于未设置的变量, 用户可以根据需要采用不同的处理方式,这可通 过变量替换来实现。 变量替换提供了三种功能:

? 允许替换未设置变量的隐含值;
? 允许对未设置变量赋值;

? 在访问未设置变量时,提示出错信息。

4.6 变量的替换(续2)
例1:${var:-word}(假设$ PARM未设置)
# echo " The value of PARM is ${PARM:-undefined}" The value of PARM is undefined # echo $PARM ? [注意] 此处的“ ?” 表示空字符 $

例2:${var:-word}(假设$ PARM未设置)
# arg=${PARM:-―not defined‖} # echo ' $arg : '$arg $arg : not defined [注意] 双引号

4.7 特殊字符的引用
消除特殊字符的含义可用转义符、单引号和双引号。

? 转义符( \) 的引用
消除紧跟在转义符后面的单个字符的特殊含义 。 例 #count=`expr count \* 10`

? 单引号 (‘’)的引用
消除被括在单引号中的所有特殊字符的含义。 例:# echo ?$count=‘$count

? 双引号 (“”)的引用
双引号能消除被括在双引号中大部分特殊字符的含义, 但不能消除 $ 、` 、" 、\ 四个字符的其特殊含义: 例: vdate=―`date` is system maintenance day !‖

4.7 特殊字符的引用(续)
? 特殊字符串引用的例外
引用双引号、单引号和转意符都不能消除对 echo命令有特殊功能的控制字串(逃逸字符)的 特殊含义。这些控制字串是:
\b \c \f \n \r \t \v \ Backspace 显示后不换行 在终端上屏幕的开始处显示 换行 回车 制表符 垂直制表符 反斜框

Shell的控制结构
?
? ? ? ? ? ?

条件和 test 命令 if 结构 case 结构 for 结构 while 结构 until 结构 循环体中的其它命令

? 简单条件

5.1 条件与 test 命令

在高级语言中判断条件依赖于运算的结果,而 Shell语言依赖条件是命令执行的“出口状态”。 Shell命令的“出口状态”($?): 成功:0 、 true 失败:x 、 false (x 为非0数值) 例:判断指定目录是否存在, 并显示相应信息。 # cat checkdir test -d $1 && echo ―$1 is a dictory‖&& exit 0 echo ―$1 is not a dictroy‖ exit 1

? test 命令

5.1 条件与 test 命令(续1)

test 命令可用于对字符串、整数及文件进行 各 类测试。其命令格式如下: test expression 或 [ expression ] 注意 [ ] 中的空格) expression 是测试的条件,计算结果: 为真,则返回“零”出口状态, 为假,否则返回“非零” 出口状态。 例:判断当前上机用户人数是否多于10 ? # test "`who | wc -l ` " -gt 10 # echo $?

5.1 条件与 test 命令(续2)
? test 字符串测试表达式
expression
string1 = string2 string1 != string2

满足下列条件时返回真值
string1与string2相同 string1与string2不相同

string
-n string -z string

string不为空串
string不为空串 string为空串

5.1 条件与 test 命令(续3)
例1:两个字符串进行比较

0 例2:查找指定的文件或目录 # cat search

# user=smith # test "$user" = smith # echo $?

test "$1" || { echo "err: no parameter" ; \ exit 1; } find . -name "$1" -print

5.1 条件与 test 命令(续4)
例2:带有空格的字符串比较 # month="January " # test "$month" = January # echo $? 1 # test $month = January # echo $? 0 区别:Shell在处理变量时,遇到有双引号将保 留其内容,而省略双引号时,将滤去空格。

5.1 条件与 test 命令(续7)
例3:带有空格的字符串比较 # a="testing string" # test "$a" = "testing string" # echo $? 0 # test $a = "testing string" test: unknown operator string Shell处理变量 $a 时,将其进行变量替换,然 后将结果(testing string)传递给test,而test将string 作为操作符来处理,因此出错。

5.1 条件与 test 命令(续8)
例4:带有空串(或未设置的字符串比较)

# name= " " # test "$name" = smith # echo $? 1 # test $name = smith test: argument expected Shell处理变量"$name"时,双引号将其括起

的内容作为一个“位置持有者”来保留,并把该 值传递给test,保证处理的正常执行。

例4:带有空串的字符串比较

5.1 条件与 test 命令(续9)
# # # 1 # # 0 blanks=" " test $blanks echo $?

test "$blanks" echo $?

Shell处理变量$blanks时,将空格滤去,使其 变为空串传递给test;而双引号保留 “位置持有 者”的位置,其值为一个空格(空白符),传递 给test。

例4:带有算符的字符串比较 # symvar="=" # test -z "$symvar" test: argument expected

5.1 条件与 test 命令(续10)

出错的原因是“=”运算符比“-z”运算符的优先级 要高,因此,test 命令期望在等号之后要有一个自变量。 为避免上述问题的发生,可用下面命令形式替换:

# test x"$symvar" = x # echo $? 1

5.1 条件与 test 命令(续11)
? test命令可用于整数比较
首先要搞清楚整数比较的两个概念:

? Shell并不区分放在Shell变量中的值的类型,
就变量本身而言,它存放的仅仅是一组字符串, 既Shell只有一种类型的变量——串变量。 ? 当使用整数比较操作符时,是test命令来解 释存放在变量中的整数值,而不是Shell。

5.1 条件与 test 命令(续12)
? test 整数测试表达式
expression
int1 -eq int2
int1 -ge int2 int1 -gt int2 int1 -le int2 int1 -lt int2

满足下列条件时返回真值
两者为数值且int1等于int2
两者为数值且int1大于或等于int2 两者为数值且int1大于int2 两者为数值且int1小于或等于int2 两者为数值且int1小于int2

int1 -ne int2

两者为数值且int1不等于int2

5.1 条件与 test 命令(续13)
例: # x1= " 005 " # x2= " 10" # test " $x1 " = 5 较 # echo $? 1 # test " $x1 " -eq 5 较 # echo $? 0 # test " $x2 " -eq 10 # echo $? ? 按串方式比

? 按数值方式比

5.1 条件与 test 命令(续14)
? test 中常用的文件测试表达式
expression
-r FileName

满足下列条件时返回真值
FileName存在且为用户可读

-w FileName
-x FileName -s FileName

FileName存在且为用户可写
FileName存在且为用户可执行 FileName存在且其长度大于0

-d FileName
-f FileName

FileName为一个目录
FileName为一个普通文件

5.1 条件与 test 命令(续15)
例1:检查指定的文件是否存在并且可读
test -f /usr/fk/message

例2:检查指定的文件是否为目录
test -d /usr/src/local/sendmail

例3:检查指定的出错文件是否为空,如不空
则列出该文件的内容。

test -s $errfile && cat $errfile

6.1 条件与 test 命令(续16)
? 表达式的逻辑运算
逻辑运算符包括: ! — 逻辑非单目运算符,可放置在任何其 它 test表达式之前,求得表达式运算结果得非值。

-a — 逻辑与运算符,执行两个表达式的逻 辑
与运算,并且仅当两者都为真时,才返回真值。 -o — 逻辑或运算符,执行两个表达式的逻

6.1 条件与 test 命令(续17)
? 逻辑运算符的优先级
? 逻辑运算符优先级(由高到低) 的排列顺


如下:

() ?

!

?

-a

?

-o

? 逻辑运算符优先级要比字符串操作符、



6.1 条件与 test 命令(续18)
? 表达式的逻辑组合
expression
! expr expr1 –a expr2 expr1 –o expr2 \(expr\)

满足下列条件时返回真值
expr返回值为假( Not ) expr1和expr2同时为真 ( And ) expr1为真或expr2为真 ( Or ) expr为真时 [注意]左右括号前要加转义符 \

6.1 条件与 test 命令(续19)
例1:当指定的文件不可读时为真。 test ! -r /usr/fk/message 例2:当指定的文件均存在,且message为可读、 $mailfile 指定的文件为普通文件时,返回真。 test -r /usr/fk/message -a -f "$mailfile "
例3:当变量值大于等于0并且小于10时为真。 test "$count " -ge 0 -a "$count " -lt 10 例4: test \( ―$a‖ -eq 0 -o "$b" -gt 5 \) -a "$c" -le 8

6.2 if 结构
? if 的简单结构
格式 if command1

then
command2

command3
… fi

6.2 if 结构(续1)
? if 的完整结构
格式 if command1 then command2 command3 … else command4 command5 … fi

6.2 if 结构(续2)
? if 的连用结构
格式1 if command1 then commands else if command2 then commands : : fi fi

6.2 if 结构(续3)
? if 的连用结构
格式2 if command1 then commands elif command2 then commands : : commands else commands fi

6.3 case 结构
格式

case value in pattern1)

command11 … command1n;; pattern2) command21 … command2n;; … … patternn) commandn1 … commandnn;; esac

6.4 for 结构
格式
for variable in arg1 arg2 … argn

do
command … command done

6.5 while 结构
格式
while command

do
command … command done

6.6 until 结构
格式
until command

do
command … command done

6.7 循环体中其它命令
? break 命令
break是Shell的内部命令,用于在循环体中根 据命令运行的返回条件,直接终止循环体内命令 的执行。 当执行break命令时,控制流从循环体中转 移

到done之后的第一条命令上。

6.7 循环体中其它命令(续1)
? continue 命令
continue是Shell的内部命令,用于在循环体 中 根据命令运行的返回条件,直接进入下一次循环

命令的执行。
当执行continue命令时,控制流直接转到本



6.8 函数的定义和使用
函数格式
FunctionName( ){ command : : command }

例: ### The test codes for function definition GetYesOrNo() { while echo ―$*(Y/N)? \c‖ > &2

6.8 函数的定义和使用(续)
do read reply RestData case ―$reply‖in

执行 # GetYesOrNo ―Do you wish to continue‖ || exit 显示 Do you wish to continue(Y/ N)?

esac done

[yY] ) return 0 ;; [nN] ) return 1 ;; * ) echo ―Please enter Y or N !‖>&2 ;;

Shell的运行环境
?
? ? ? ?

局部变量
全局变量 局部变量和全局变量作用域

程序调试
Shell程序的应用

7.1 局部变量
在某一局部特定环境下使用的变量 。
? 注册Shell在接受到用户输入的命令(非内部 命令)后,通常派生出一个子Shell,由此子Shell 负责解释执行该命令。 ? 子Shell有自己的运行环境和变量,这些变量 仅在子Shell的范围内的特定环境下才能使用。 ? 子Shell不能存取由父Shell设置的局部变量,

也不能改变父Shell的变量值。

7.1 局部变量(续)
例1: # cat vartest1 echo :$x: # x=100 # vartest1 :: 例2: # cat vartest2 x=60 echo :$x: # x=10 # vartest2 :60: # echo $x 10

全局变量是一种特殊的变量,可以被任何运行 的子Shell来引用。全局变量通过export命令来定 义,格式如下: export variables 其中 variables 是要变成全局变量的变量表名。 ? 一旦变量被定义为全局变量,则对于以后的 所有子Shell来说这些都是全局变量; ? 子Shell中无法改变全局变量的值; ? 若在子Shell中改变全局变量的值,实际是对 全局变量的副本进行更改,不影响全局变量值; ? 子Shell中局部变量的使用优先于全局变量。

7.2 全局变量

7.2 全局变量(续)
例: # export g_var
# g _var="GLOBAL" # cat test_var export g_var l_var g_var="sub_shell:g_var" l_var="sub_shell:l_var" echo $g_var $l_var # test_var sub_shell:g_var sub_shell:l_var # echo $g_var :$l_var: GLOBAL :: #

7.3 局部变量和全局变量作用 域
? 任何没有用export命令定义过的变量是局部变 量,子Shell不能存取父Shell的局部变量; ? 子Shell中可以存取和修改父Shell的全局变量, 但这种修改对于父Shell全局变量没有任何影响; ? 在子Shell中用export命令定义的全局变量和对 此变量的修改对父Shell变量没有影响; ? 全局变量保持它的全局性,不仅能直接传递给 它的子Shell,而且子Shell还能将它传递给子Shell 的子Shell; ? 在对变量赋值之前和之后的任何时候可以将该 变量转换成全局变量。

7.4 程序调试
Shell提供了多种工具以便在调试Shell程序
时使用,这些工具允许观察一个Shell程序的执

行。
常用的测试方式有: Shell程序的详细跟踪;

Shell程序的跟踪执行;

7.4 程序调试(续1)
? Shell程序的详细跟踪
Shell提供的详细跟踪特性允许用户观察一个 Shell程序的读入和执行,如果在读入命令行时发 现语法错误,则终止程序的执行。命令行被读入 后,Shell按读入时的形式在标准错误输出中显示 该命令行,然后执行命令行。详细跟踪Shell程序 的执行有两种方式: 整个程序的详细跟踪和局部程序的详细跟踪。

? 整个程序的跟踪执行

7.4 程序调试(续2)
格式 sh -v shprog 用来实现对整个文件的脚本进行跟踪。

? 局部程序的跟踪执行 格式 set -v —— 设置跟踪标志 set +v —— 关闭跟踪标志
用来实现对文件中的部分脚本进行跟踪。

7.4 程序调试(续3)

例: # cat traced date echo $PATH | wc -c # traced 1998年 11月 05日 星期四 17时 29分 59秒 CST 45 # sh -v traced date 1998年 11月 05日 星期四 17时 30分 08秒 CST echo $PATH | wc -c 45

? Shell程序的跟踪执行

7.4 程序调试(续4)

Shell的跟踪执行功能允许用户观察一个Shell 程序的执行,它使命令行在执行前完成所有替换 之后,在标准错误输出中显示每一个被替换后的 命令行,并且在行前加上前缀符号“+‖(但变 量赋值语句不加“+‖符号),然后执行命令。 同详细跟踪一样,对Shell程序的跟踪执行也 有两种方式: 整个程序的跟踪执行和局部程序的跟踪执行。

? 整个程序的跟踪执行

7.4 程序调试(续5)
格式 sh -x shprog 用来实现对整个文件脚本的跟踪执行。

? 局部程序的跟踪执行 格式 set -x —— 设置跟踪标志 set +x —— 关闭跟踪标志
用来实现对文件中部分脚本的跟踪执行。

7.4 程序调试(续6)
例: # cat traced date echo $PATH | wc -c # sh -x traced +date 1998年 11月 05日 星期四 17时 30分 08秒 CST +echo /bin:/usr/bin:/usr/fk/bin /bin:/usr/bin:/usr/fk/bin +wc -c 25

? 详细跟踪与跟踪执行的组合
? 整个程序的跟踪执行
格式 sh -vx shprog

7.4 程序调试(续7)

? 局部程序的跟踪执行
格式

set -vx set +vx

—— 设置跟踪标志 —— 关闭跟踪标志

7.5 Shell程序的应用
? Shell程序的定义
若一个文件包含了一串简单命令串时,称为 命令文件;若一个文件包含了一组更为复杂的命 令组合(常常使用了Shell的条件命令、控制结构 和其它高级特性)时,就称之为Shell程序(或称 Shell过程)。通常情况下,两者的称呼并没有明 确的区别。 在Shell程序设计语言里的基本操作是UNIX系 统命令,它是UNIX系统中最有生气的部分,而且 对于UNIX系统的使用极为重要。

? 何时使用Shell程序设计语言

7.5 Shell程序的应用(续)

? 当一个问题的解决方法包含了许多UNIX系统 的标准命令操作时,可使用Shell程序设计语言; ? 如果一个问题能用在UNIX系统中已建立的基 本操作所表示,则使用Shell程序设计语言能构成 更强的功能; ? 如果处理问题的基本数据是正文行或文件, 则Shell可描述一个很好的解决方法;若基本数据 是数字或字符,则使用Shell可能不是好办法; ? 使用Shell程序的最后一个准则是程序的开发 成本。


搜索更多“UNIX Shell 程序设计”

网站地图

All rights reserved Powered by 伤城文章网 5xts.com

copyright ©right 2010-2021。
伤城文章网内容来自网络,如有侵犯请联系客服。zhit325@126.com